# Preprocessing and Psychometrics

# Clustering, PCA and ICA
## Load Data

```{r}
#TODO set all.x = TRUE in merge commands
# We start with loading the LC Basis Data
file_path <- "/data/p_02571/lifedata/data/pv712_join_20230725.xlsx"
LC_df <- read_xlsx(file_path) %>% as_tibble() #%>% rename(SIC = TEILNEHMER_SIC)

mr_path <- "/data/p_02571/lifedata/data/PV0712_T01477_NODUP.xlsx"
mrtv_df <- read_xlsx(mr_path) %>% as_tibble()

zuordnung_path <- "/data/pt_02571/Data/01_sample/MRT_Zuordnung_SIC_GeraeteID.xlsx"
zuordnung_df <- read_xlsx(zuordnung_path) %>% as_tibble() %>% filter(!is.na(geraet))

#LC_df <- merge(LC_df, mrtv_df, by = "SIC")
LC_df <- LC_df %>% rename(geraet = LC_MRTV_F0013) %>% filter(!is.na(geraet)) 
LC_df <-  merge(LC_df, zuordnung_df, by = "geraet") 

symptoms_path <- "/data/pt_02571/Data/01_sample/Samples_LIFE.xlsx"
symptoms_df <- read_xlsx(symptoms_path, col_types = c("guess", "guess", "date", "guess", "guess", "date", "guess", "guess", "guess", "guess", "guess", "guess", "guess", "guess", "date", rep("guess", 21))) %>% as_tibble() %>% filter(MRI_Rec != 0)


LC_df <- merge(LC_df, symptoms_df, by = "LI_Nr")

LC_df$LDI %>% head()

# LC_df <- LC_df %>% select(-contains("SOZIO"), 
#          -contains("REHABNEQ"), 
#          -contains("DIPS"),
#          -contains("PCFS"), 
#          -contains("LSNS"),
#          -contains("ANTHRO"),
#          -contains("CESD"),
#          -contains("BPSI"),
#          -contains("MEDIZANAM"),
#          -contains("MRTV"),
#          -contains("MST"),
#          -contains("MEDIKAN"),
#          -contains("KARDANAM"))

#view(symptoms_df)
#anamnese_df <- LC_df %>%
#  select(contains("MST"))
```

## Preprocessing LCBasis
### util functions
```{r util}
# For scaling to zero-one
rescale_to_zero_one <- function(...){
  (... - min(..., na.rm = TRUE))/(max(..., na.rm = TRUE) - min(..., na.rm = TRUE))
}

# see PCA, methods nature 2022
rss <- function(X, A){
  sum((X - A)^2, na.rm = TRUE)
}

# simple imputation algorithm leaning on SVD

mPCA <- function(X, rank, maxit = 100, thresh = 1e-5){
  A <- outer(rep(1, nrow(X)), colMeans(X, na.rm = T))
  score0 <- rss(X, A)
  delta <- Inf
  it <- 0
  while(it < maxit & delta > thresh){
    #impute
    Xtilde <- X
    Xtilde[is.na(X)] <- A[is.na(X)]
    #center
    m <- colMeans(Xtilde)
    Xtilde <- scale(Xtilde, center = m, scale = F)
    #lrma
    SVD <- svd(Xtilde)
    A <- SVD$u[, 1:rank, drop = F] %*% diag(SVD$d[1:rank], rank, rank) %*% t(SVD$v[, 1:rank, drop = F])
    #unscale
    A <- scale(A, center = -m, scale = F)
    #loss
    score <- rss(X, A)
    delta <- abs((score - score0)/score0)
    #cat("iter", it , "rss", score, "delta", delta, "\n")
    score0 <- score
    it <- it + 1
  }
  return(score)
}

mPCAnull <- function(X){
  A <- outer(rep(1, nrow(X)), colMeans(X, na.rm = T))
  score0 <- rss(X, A)
  return(score0)
}
```

### Cognitive Measures

#### MST
```{r}
#LC_df <- merge(LC_df, mst_df, by = "LI_Nr")

# mst_lc1_path <- "/data/pt_02571/Results/MST/LC1/20230626_A1_LC1_mst_results.csv"
# mst_lc1_df <- read_csv(mst_lc1_path) %>% rename(geraet = ID)
# 
# mst_lc2_path <- "/data/pt_02571/Results/MST/LC2/20230622_A1_LC2_mst_results.csv"
# mst_lc2_df <- read_csv(mst_lc1_path) %>% rename(geraet = ID)

mst_path <- "/data/p_02571/MST/mst_results.csv"
mst_df <- read_csv(mst_path) %>% rename(geraet = ID)

translation <- "/data/p_02571/lifedata/data/PV0712_T01442_NODUP.xlsx"

translation_df <- read_xlsx(translation) %>% rename(geraet = LC_MST_F0013)
# dont run command below - seemingly some translation errors, we first have to change some IDs from mst data
# mst_df <- merge(mst_df, translation_df, by = "geraet")

test_names <- mst_df$geraet
false_names <- sapply(test_names, function(t) t %in% translation_df$geraet)[!(sapply(test_names, function(t) t %in% translation_df$geraet))]

mst_df <- mst_df %>% mutate(geraet = case_when(
  geraet == "5000Kj9Z" ~ "500Kj9Z",
  geraet == "b000Klxq" ~ "b00Klxq",
  geraet == "d000KdlF" ~ "d00KdlF",
  geraet == "h000KdlK" ~ "h00KdlK",
  geraet == "M000Km5p" ~ "M00Km5p",
  geraet == "T000Km8e" ~ "T00Km8e",
  geraet == "Y000KmaK" ~ "Y00KmaK",
  .default = geraet)
)

mst_df <- merge(mst_df, translation_df, by = "geraet")
# has yet to be worked out
#LC_df <-merge(LC_df, mst_df, by = "geraet")

```

#### TMT
```{r tmt}
## TMT ##
tmt_df <- LC_df %>% select(SIC, contains("TMT")) %>%
  select(SIC, LC_TMT_F0011, LC_TMT_F0014)
# have a look at the distr. for each, tmt_a and _b
for (tmt in c("LC_TMT_F0011", "LC_TMT_F0014")){
  plot = ggplot(data=tmt_df) + geom_freqpoly(aes_string(x=tmt))
  print(plot)
}

  LC_df <- LC_df %>% mutate(tmt_a_score = LC_TMT_F0011, 
                            tmt_b_score = LC_TMT_F0014,
                            tmt_score = tmt_b_score/tmt_a_score)
plot = ggplot(data=LC_df) + geom_freqpoly(aes(x=tmt_score))
print(plot)
```

#### MoCa
We still have to figure out which items are used for the typical moca score....
```{r moca}

moca_df <- LC_df %>% select(SIC, contains("MOCA2")) %>%
  select(-contains("F0032"), 
         -contains("F0033"), 
         -contains("F0034"), 
         -contains("F0035"), 
         -contains("F0036")) 
moca_score <- moca_df %>% select(LC_MOCA2_F0010:LC_MOCA2_F0053) %>% 
  select(-(LC_MOCA2_F0019:LC_MOCA2_F0028)) %>%
  mutate(moca_score = rowSums(across(where(is.numeric)), na.rm = TRUE)) 

moca_score$moca_score[moca_score$moca_score == 0] <- NA

ggplot(data = moca_score) + geom_freqpoly(aes(x = moca_score^2))
ggplot(data = moca_score) + geom_freqpoly(aes(x = moca_score))

LC_df <- LC_df %>% mutate(moca_score = moca_score$moca_score)
```
#### MFI

```{r mfi}

mfi_df <- LC_df %>% select(SIC, contains("MFI")) %>%
  # preprocess inverted items
  mutate(LC_MFI20_I02 = abs(LC_MFI20_I02 - 6),
         LC_MFI20_I05 = abs(LC_MFI20_I05 - 6),
         LC_MFI20_I09 = abs(LC_MFI20_I09 - 6),
         LC_MFI20_I10 = abs(LC_MFI20_I10 - 6),
         LC_MFI20_I13 = abs(LC_MFI20_I13 - 6),
         LC_MFI20_I14 = abs(LC_MFI20_I14 - 6),
         LC_MFI20_I16 = abs(LC_MFI20_I16 - 6),
         LC_MFI20_I17 = abs(LC_MFI20_I17 - 6),
         LC_MFI20_I18 = abs(LC_MFI20_I18 - 6),
         LC_MFI20_I19 = abs(LC_MFI20_I19 - 6)) %>%
  # get scores for 5 subscales
  mutate(general_fatigue_score = LC_MFI20_I01 + LC_MFI20_I05 + LC_MFI20_I12 + LC_MFI20_I16,
         physical_fatigue_score = LC_MFI20_I02 + LC_MFI20_I08 + LC_MFI20_I14 + LC_MFI20_I20,
         reduced_motivation_score = LC_MFI20_I04 + LC_MFI20_I09 + LC_MFI20_I15 + LC_MFI20_I18,
         reduced_activity_score = LC_MFI20_I03 + LC_MFI20_I06 + LC_MFI20_I10 + LC_MFI20_I17,
         mental_fatigue_score = LC_MFI20_I07 + LC_MFI20_I11 + LC_MFI20_I13 + LC_MFI20_I19)
LC_df <- LC_df %>% mutate(general_fatigue_score = mfi_df$general_fatigue_score,
                          physical_fatigue_score = mfi_df$physical_fatigue_score,
                          reduced_motivation_score = mfi_df$reduced_motivation_score,
                          reduced_activity_score  = mfi_df$reduced_activity_score,
                          mental_fatigue_score = mfi_df$mental_fatigue_score)
for (fatigue in c("general_fatigue_score", 
                  "physical_fatigue_score", 
                  "reduced_motivation_score", 
                  "reduced_activity_score", 
                  "mental_fatigue_score")){
  plot = ggplot(data=LC_df) + geom_freqpoly(aes_string(x=fatigue))
  print(plot)
}
```

#### CERAD Wortlisten

```{r Wortlisten}

wl_df <- LC_df %>% select(SIC, contains("WL")) 
wl_score <- wl_df %>% 
  mutate(learning_score = rowSums(across(LC_WL_F0023:LC_WL_F0032)) + 
           rowSums(across(LC_WL_F0040:LC_WL_F0049)) +
           rowSums(across(LC_WL_F0057:LC_WL_F0066)),
         recognition_score = rowSums(across(LC_WL_F0102:LC_WL_F0121)),
         recall_score = rowSums(across(LC_WL_F0085:LC_WL_F0094))) #%>%
  #select(-(LC_WL_F0102:LC_WL_F0121), LC_WL_F0085:LC_WL_F0094)

LC_df <- LC_df %>% mutate(learning_score = wl_score$learning_score,
                          recognition_score = wl_score$recognition_score, 
                          recall_score = wl_score$recall_score)

for (cerad in c("learning_score", "recognition_score", "recall_score")){
  plot = ggplot(data=LC_df) + geom_freqpoly(aes_string(x=cerad))
  print(plot)
}
```

#### TILS
```{r tils}

tils_df <- LC_df %>% select(SIC, contains("TILS"))
tils_score <- tils_df %>% select(LC_TILS_F0009:LC_TILS_F0011) %>% 
  mutate(tils_score = rowSums(across(where(is.numeric))))
LC_df <- LC_df %>% mutate(tils_score = tils_score$tils_score)

  plot = ggplot(data=LC_df) + geom_freqpoly(aes(x=tils_score))
  print(plot)

```

#### PSQI
```{r psqi}
psqi_df <- LC_df %>% select(SIC, contains("PSQI")) %>%
  rowwise() %>%
  mutate(LC_PSQI_I01 = hms::hms(hours = as.numeric(str_split(LC_PSQI_I01, ":")[[1]][1]), 
                                minutes = as.numeric(str_split(LC_PSQI_I01, ":")[[1]][2])),
         LC_PSQI_I03 = hms::hms(hours = as.numeric(str_split(LC_PSQI_I03, ":")[[1]][1]), 
                                minutes = as.numeric(str_split(LC_PSQI_I03, ":")[[1]][2]))) %>%
  ungroup() %>%
  mutate(schlafqualitaet = LC_PSQI_I06 - 1,
         schlaflatenz_k1 = case_when(
           LC_PSQI_I02 <= 15 ~ 0,
          LC_PSQI_I02 >= 16 & LC_PSQI_I02 <31 ~ 1,
          LC_PSQI_I02 >= 31 & LC_PSQI_I02 <= 60 ~ 2,
          LC_PSQI_I02 > 60 ~ 3,
          TRUE ~ NA_integer_),
         schlaflatenz = schlaflatenz_k1 + LC_PSQI_I05A -1,
         schlafdauer = case_when(
           LC_PSQI_I04 >= 7 ~ 0,
           LC_PSQI_I04 < 7 & LC_PSQI_I04 >= 6 ~ 1,
           LC_PSQI_I04 < 6 & LC_PSQI_I04 >= 5 ~ 2,
           LC_PSQI_I04 < 5 ~ 3),
         bettzeit = case_when(
           ((as.numeric(hms::hms(hours(24))) - as.numeric(LC_PSQI_I01)) <= (as.numeric(hms::hms(hours(24))) - as.numeric(hms::hms(hours(16))))) ~ ((as.numeric(hms::hms(hours(24))) - as.numeric(LC_PSQI_I01)) + as.numeric(LC_PSQI_I03)),
           (as.numeric(LC_PSQI_I01) < as.numeric(LC_PSQI_I03)) ~
             (as.numeric(LC_PSQI_I03) - as.numeric(LC_PSQI_I01)),
         TRUE ~ NA_integer_)) %>%
  mutate(schlafeffizienz = (LC_PSQI_I04/bettzeit) * 100) %>%
  mutate(schlafeffizienz = case_when(
    schlafeffizienz >= 85 ~ 0,
    schlafeffizienz >= 75 & schlafeffizienz < 85 ~ 1,
    schlafeffizienz >= 65 & schlafeffizienz < 75 ~ 2,
    schlafeffizienz < 65 ~ 3)) %>%
  mutate(schlafeffizienz = case_when(
    is.na(schlafeffizienz) ~ 3,
    TRUE ~ schlafeffizienz)) %>%
  mutate(LC_PSQI_I05B = LC_PSQI_I05B - 1,
         LC_PSQI_I05C = LC_PSQI_I05C - 1,
         LC_PSQI_I05D = LC_PSQI_I05D - 1,
        LC_PSQI_I05E = LC_PSQI_I05E - 1,
         LC_PSQI_I05F = LC_PSQI_I05F - 1,
         LC_PSQI_I05G = LC_PSQI_I05G - 1,
         LC_PSQI_I05H = LC_PSQI_I05H - 1,
         LC_PSQI_I05I = LC_PSQI_I05I - 1,
         LC_PSQI_I05J = LC_PSQI_I05J - 1) %>%
  mutate(schlafstoerungen = LC_PSQI_I05B + LC_PSQI_I05C + 
           LC_PSQI_I05D + LC_PSQI_I05E + LC_PSQI_I05F +
           LC_PSQI_I05G + LC_PSQI_I05H + LC_PSQI_I05I + 
           LC_PSQI_I05J) %>%
  mutate(schlafstoerungen = case_when(
    schlafstoerungen == 0 ~ 0,
    schlafstoerungen >= 1 & schlafstoerungen < 10 ~ 1,
    schlafstoerungen >= 10 & schlafstoerungen < 19 ~ 1,
    schlafstoerungen >= 19 & schlafstoerungen < 28 ~ 1,
    TRUE ~ NA_integer_)) %>%
  mutate(schlafmittelkonsum = LC_PSQI_I07 - 1,
         tagesmuedigkeit = case_when(
           (LC_PSQI_I08 + LC_PSQI_I09 - 2) == 0 ~ 0,
           (LC_PSQI_I08 + LC_PSQI_I09 - 2) >= 1 & 
             (LC_PSQI_I08 + LC_PSQI_I09) - 2 <= 2 ~ 1,
           (LC_PSQI_I08 + LC_PSQI_I09) - 2 >= 3 & 
             (LC_PSQI_I08 + LC_PSQI_I09) - 2 <= 4 ~ 2,
           (LC_PSQI_I08 + LC_PSQI_I09) - 2 >= 5 & 
             (LC_PSQI_I08 + LC_PSQI_I09) - 2 <= 6 ~ 3,
           TRUE ~ NA_integer_)) %>%
  mutate(psqi_score = schlafqualitaet + schlaflatenz +
           schlafdauer + schlafeffizienz + 
           schlafstoerungen + schlafmittelkonsum +
           tagesmuedigkeit)
LC_df <- LC_df %>% mutate(schlafqualitaet_score = psqi_df$schlafqualitaet,
                          schlaflatenz_score = psqi_df$schlaflatenz,
                          schlafdauer_score = psqi_df$schlafdauer,
                          schlafeffizienz_score = psqi_df$schlafeffizienz,
                          schlafstoerungen_score = psqi_df$schlafstoerungen,
                          schlafmittelkonsum_score = psqi_df$schlafmittelkonsum,
                          tagesmuedigkeit_score = psqi_df$tagesmuedigkeit,
                          psqi_score = psqi_df$psqi_score)

for (psqi in c("schlafqualitaet_score", 
               "schlaflatenz_score", 
               "schlafdauer_score", 
               "schlafeffizienz_score", 
               "schlafstoerungen_score", 
               "schlafmittelkonsum_score", 
               "tagesmuedigkeit_score", 
               "psqi_score")){
  plot = ggplot(data=LC_df) + geom_freqpoly(aes_string(x=psqi))
  print(plot)
}  
```

#### PSS
```{r pss}

pss_df <- LC_df %>% select(SIC, contains("PSS")) %>%
  #reverse respective scores
  mutate(LC_PSS_F0012 = abs(LC_PSS_F0012 - 6),
         LC_PSS_F0013 = abs(LC_PSS_F0013 - 6),
         LC_PSS_F0015 = abs(LC_PSS_F0015 - 6),
         LC_PSS_F0016 = abs(LC_PSS_F0016 - 6))
pss_score <- pss_df %>% select(LC_PSS_F0009:LC_PSS_F0018) %>% 
  mutate(pss_score = rowSums(across(where(is.numeric))))

LC_df <- LC_df %>% mutate(pss_score = pss_score$pss_score)

ggplot(data = LC_df) + geom_freqpoly(aes(x=pss_score))
```

#### VSAQ

```{r vsaq}
vsaq_df <- LC_df %>% select(SIC, contains("VSAQ")) %>%
   mutate(score = rowSums(across(where(is.numeric)))) 
vsaq_score <- vsaq_df %>% select(LC_VSAQ_F0009:LC_VSAQ_F0021) %>% 
  mutate(vsaq_score = rowSums(across(where(is.numeric)))) 

LC_df <- LC_df %>% mutate(vsaq_score= vsaq_score$vsaq_score)

ggplot(data = LC_df) + geom_freqpoly(aes(vsaq_score))
```

#### Kard.Anamnese
```{r kardanam}
#kardanam_df <- LC_df %>% select(SIC, contains("KARDANAM"))
```

#### Handkraftmessung
```{r hk}
hk_df <- LC_df %>% select(SIC, contains("HK")) %>%
  select(SIC,LC_HK_F0015:LC_HK_F0040) %>% 
  mutate(hk_score = (LC_HK_F0015 + LC_HK_F0020 +
                    LC_HK_F0025 + LC_HK_F0030 + 
                    LC_HK_F0035 + LC_HK_F0040)/6)

LC_df <- LC_df %>% mutate(hk_score = hk_df$hk_score)

ggplot(data = LC_df) + geom_freqpoly(aes(hk_score))
```


#### Olfactory
```{r riechen}

riechen_df <- LC_df %>% select(SIC, contains("RIECHEN")) %>%
  mutate(riechen_score = LC_RIECHEN_F0030)

LC_df <- LC_df %>% mutate(olfaction_score = riechen_df$riechen_score)

ggplot(data = LC_df) + geom_freqpoly(aes(olfaction_score))
```

#### Gustatory
```{r schmecken}
schmeck_df <- LC_df %>% select(SIC, contains("SCHMECK"))
LC_df <- LC_df %>%
  mutate(LC_SCHMECK_F0013 = case_when(LC_SCHMECK_F0013 == "5" ~ 5,
                                  LC_SCHMECK_F0013 == "1" ~ 1,
                                  LC_SCHMECK_F0013 == "2" ~ 2,
                                  LC_SCHMECK_F0013 == "3" ~ 3,
                                  LC_SCHMECK_F0013 == "4" ~ 4,
                                  TRUE ~ NA_integer_), 
         LC_SCHMECK_F0014 = case_when(LC_SCHMECK_F0014 == "5" ~ 5,
                                  LC_SCHMECK_F0014 == "1" ~ 1,
                                  LC_SCHMECK_F0014 == "2" ~ 2,
                                  LC_SCHMECK_F0014 == "3" ~ 3,
                                  LC_SCHMECK_F0014 == "4" ~ 4,
                                  TRUE ~ NA_integer_),
         LC_SCHMECK_F0015 = case_when(LC_SCHMECK_F0015 == "5" ~ 5,
                                  LC_SCHMECK_F0015 == "1" ~ 1,
                                  LC_SCHMECK_F0015 == "2" ~ 2,
                                  LC_SCHMECK_F0015 == "3" ~ 3,
                                  LC_SCHMECK_F0015 == "4" ~ 4,
                                  TRUE ~ NA_integer_),
         LC_SCHMECK_F0016 = case_when(LC_SCHMECK_F0016 == "5" ~ 5,
                                  LC_SCHMECK_F0016 == "1" ~ 1,
                                  LC_SCHMECK_F0016 == "2" ~ 2,
                                  LC_SCHMECK_F0016 == "3" ~ 3,
                                  LC_SCHMECK_F0016 == "4" ~ 4,
                                  TRUE ~ NA_integer_),
         LC_SCHMECK_F0017 = case_when(LC_SCHMECK_F0017 == "5" ~ 5,
                                  LC_SCHMECK_F0017 == "1" ~ 1,
                                  LC_SCHMECK_F0017 == "2" ~ 2,
                                  LC_SCHMECK_F0017 == "3" ~ 3,
                                  LC_SCHMECK_F0017 == "4" ~ 4,
                                  TRUE ~ NA_integer_),
         LC_SCHMECK_F0018 = case_when(LC_SCHMECK_F0018 == "5" ~ 5,
                                  LC_SCHMECK_F0018 == "1" ~ 1,
                                  LC_SCHMECK_F0018 == "2" ~ 2,
                                  LC_SCHMECK_F0018 == "3" ~ 3,
                                  LC_SCHMECK_F0018 == "4" ~ 4,
                                  TRUE ~ NA_integer_),
         LC_SCHMECK_F0019 = case_when(LC_SCHMECK_F0019 == "5" ~ 5,
                                  LC_SCHMECK_F0019 == "1" ~ 1,
                                  LC_SCHMECK_F0019 == "2" ~ 2,
                                  LC_SCHMECK_F0019 == "3" ~ 3,
                                  LC_SCHMECK_F0019 == "4" ~ 4,
                                  TRUE ~ NA_integer_),
         LC_SCHMECK_F0020 = case_when(LC_SCHMECK_F0020 == "5" ~ 5,
                                  LC_SCHMECK_F0020 == "1" ~ 1,
                                  LC_SCHMECK_F0020 == "2" ~ 2,
                                  LC_SCHMECK_F0020 == "3" ~ 3,
                                  LC_SCHMECK_F0020 == "4" ~ 4,
                                  TRUE ~ NA_integer_),
         LC_SCHMECK_F0021 = case_when(LC_SCHMECK_F0021 == "5" ~ 5,
                                  LC_SCHMECK_F0021 == "1" ~ 1,
                                  LC_SCHMECK_F0021 == "2" ~ 2,
                                  LC_SCHMECK_F0021 == "3" ~ 3,
                                  LC_SCHMECK_F0021 == "4" ~ 4,
                                  TRUE ~ NA_integer_),
         LC_SCHMECK_F0022 = case_when(LC_SCHMECK_F0022 == "5" ~ 5,
                                  LC_SCHMECK_F0022 == "1" ~ 1,
                                  LC_SCHMECK_F0022 == "2" ~ 2,
                                  LC_SCHMECK_F0022 == "3" ~ 3,
                                  LC_SCHMECK_F0022 == "4" ~ 4,
                                  TRUE ~ NA_integer_),
         LC_SCHMECK_F0023 = case_when(LC_SCHMECK_F0023 == "5" ~ 5,
                                  LC_SCHMECK_F0023 == "1" ~ 1,
                                  LC_SCHMECK_F0023 == "2" ~ 2,
                                  LC_SCHMECK_F0023 == "3" ~ 3,
                                  LC_SCHMECK_F0023 == "4" ~ 4,
                                  TRUE ~ NA_integer_),
         LC_SCHMECK_F0024 = case_when(LC_SCHMECK_F0024 == "5" ~ 5,
                                  LC_SCHMECK_F0024 == "1" ~ 1,
                                  LC_SCHMECK_F0024 == "2" ~ 2,
                                  LC_SCHMECK_F0024 == "3" ~ 3,
                                  LC_SCHMECK_F0024 == "4" ~ 4,
                                  TRUE ~ NA_integer_),
         LC_SCHMECK_F0025 = case_when(LC_SCHMECK_F0025 == "5" ~ 5,
                                  LC_SCHMECK_F0025 == "1" ~ 1,
                                  LC_SCHMECK_F0025 == "2" ~ 2,
                                  LC_SCHMECK_F0025 == "3" ~ 3,
                                  LC_SCHMECK_F0025 == "4" ~ 4,
                                  TRUE ~ NA_integer_),
         LC_SCHMECK_F0026 = case_when(LC_SCHMECK_F0026 == "5" ~ 5,
                                  LC_SCHMECK_F0026 == "1" ~ 1,
                                  LC_SCHMECK_F0026 == "2" ~ 2,
                                  LC_SCHMECK_F0026 == "3" ~ 3,
                                  LC_SCHMECK_F0026 == "4" ~ 4,
                                  TRUE ~ NA_integer_),
         LC_SCHMECK_F0027 = case_when(LC_SCHMECK_F0027 == "5" ~ 5,
                                  LC_SCHMECK_F0027 == "1" ~ 1,
                                  LC_SCHMECK_F0027 == "2" ~ 2,
                                  LC_SCHMECK_F0027 == "3" ~ 3,
                                  LC_SCHMECK_F0027 == "4" ~ 4,
                                  TRUE ~ NA_integer_),
         LC_SCHMECK_F0028 = case_when(LC_SCHMECK_F0028 == "5" ~ 5,
                                  LC_SCHMECK_F0028 == "1" ~ 1,
                                  LC_SCHMECK_F0028 == "2" ~ 2,
                                  LC_SCHMECK_F0028 == "3" ~ 3,
                                  LC_SCHMECK_F0028 == "4" ~ 4,
                                  TRUE ~ NA_integer_),
         LC_SCHMECK_F0029 = case_when(LC_SCHMECK_F0029 == "5" ~ 5,
                                  LC_SCHMECK_F0029 == "1" ~ 1,
                                  LC_SCHMECK_F0029 == "2" ~ 2,
                                  LC_SCHMECK_F0029 == "3" ~ 3,
                                  LC_SCHMECK_F0029 == "4" ~ 4,
                                  TRUE ~ NA_integer_),
         LC_SCHMECK_F0030 = case_when(LC_SCHMECK_F0030 == "5" ~ 5,
                                  LC_SCHMECK_F0030 == "1" ~ 1,
                                  LC_SCHMECK_F0030 == "2" ~ 2,
                                  LC_SCHMECK_F0030 == "3" ~ 3,
                                  LC_SCHMECK_F0030 == "4" ~ 4,
                                  TRUE ~ NA_integer_),
         LC_SCHMECK_F0031 = case_when(LC_SCHMECK_F0031 == "5" ~ 5,
                                  LC_SCHMECK_F0031 == "1" ~ 1,
                                  LC_SCHMECK_F0031 == "2" ~ 2,
                                  LC_SCHMECK_F0031 == "3" ~ 3,
                                  LC_SCHMECK_F0031 == "4" ~ 4,
                                  TRUE ~ NA_integer_))


LC_df <- LC_df %>%
  mutate(gustatory_score = rowSums(across(LC_SCHMECK_F0013:LC_SCHMECK_F0031), 
                                   na.rm = TRUE))

# for(olf in sprintf("LC_SCHMECK_F0%03d",c(13:31))){
#   plot <- ggplot(data = LC_df) + geom_freqpoly(aes_string(olf)) 
#   print(plot)
# }
ggplot(LC_df) + geom_freqpoly(aes(gustatory_score))
```

#### GAD
```{r gad}
gad_df <- LC_df %>% select(SIC, contains("GAD"))
gad_score <- gad_df %>% select(LC_GAD_F0009:LC_GAD_F0015) %>% 
  mutate(gad_score = rowSums(across(where(is.numeric)), 
                             na.rm = TRUE))
LC_df <- LC_df %>% mutate(gad_score = gad_score$gad_score)
ggplot(data = LC_df) + geom_freqpoly(aes(x=gad_score))
```

#### Subj. Memory
```{r memory}

memory_df <- LC_df %>% select(SIC, contains("MEMORY"))
memory_score <- memory_df %>% select(LC_MEMORY_F0009:LC_MEMORY_F0017,
        LC_MEMORY_F0019:LC_MEMORY_F0023)
memory_score[memory_score >= 98] <- NA
memory_score <- memory_score %>% 
  mutate(memory_score = rowSums(across(where(is.numeric)), 
                                na.rm = TRUE))

LC_df <- LC_df %>% mutate(memory_score = memory_score$memory_score)

ggplot(data = LC_df) + geom_freqpoly(aes(x=memory_score))
```

#### ESS
```{r ess}

ess_df <- LC_df %>% select(SIC, contains("ESS"))

ess_score <- ess_df %>% select(LC_ESS_I01:LC_ESS_I08) %>%
  mutate(ess_score = rowSums(across(where(is.numeric)), na.rm = TRUE))

LC_df <- LC_df %>% mutate(ess_score = ess_score$ess_score)

ggplot(data=LC_df) + geom_freqpoly(aes(x = ess_score))
```

#### cerad word fluency

```{r word fluency}
cerad_df <- LC_df %>% select(SIC, contains("CERAD")) %>% 
  mutate(cerad_score = LC_CERAD_F0014  + LC_CERAD_F0015 + LC_CERAD_F0016 + LC_CERAD_F0017) %>%
  select(SIC, cerad_score)

LC_df <- LC_df %>% mutate(cerad_score = cerad_df$cerad_score)
ggplot(data = LC_df) + geom_freqpoly(aes(x=cerad_score))
```

#### Caortis Befund
```{r}

cab_df <- LC_df %>% select(SIC, contains("CAB"))
```

#### alcohol
```{r alc}
alk_df <- LC_df %>% select(contains("ALK_F")) %>% 
  mutate(LC_ALK_F0009 = case_when(LC_ALK_F0009 == "0" ~ 0,
                                  LC_ALK_F0009 == "1" ~ 1,
                                  LC_ALK_F0009 == "2" ~ 2,
                                  LC_ALK_F0009 == "3" ~ 3,
                                  LC_ALK_F0009 == "4" ~ 4,
                                  TRUE ~ NA_integer_), 
         LC_ALK_F0010 = case_when(LC_ALK_F0010 == "0" ~ 0,
                                  LC_ALK_F0010 == "1" ~ 1,
                                  LC_ALK_F0010 == "2" ~ 2,
                                  LC_ALK_F0010 == "3" ~ 3,
                                  LC_ALK_F0010 == "4" ~ 4,
                                  TRUE ~ NA_integer_),
         LC_ALK_F0011 = case_when(LC_ALK_F0011 == "0" ~ 0,
                                  LC_ALK_F0011 == "1" ~ 1,
                                  LC_ALK_F0011 == "2" ~ 2,
                                  LC_ALK_F0011 == "3" ~ 3,
                                  LC_ALK_F0011 == "4" ~ 4,
                                  TRUE ~ NA_integer_),
         LC_ALK_F0012 = case_when(LC_ALK_F0012 == "0" ~ 0,
                                  LC_ALK_F0012 == "1" ~ 1,
                                  LC_ALK_F0012 == "2" ~ 2,
                                  LC_ALK_F0012 == "3" ~ 3,
                                  LC_ALK_F0012 == "4" ~ 4,
                                  TRUE ~ NA_integer_),
         LC_ALK_F0013 = case_when(LC_ALK_F0013 == "0" ~ 0,
                                  LC_ALK_F0013 == "1" ~ 1,
                                  LC_ALK_F0013 == "2" ~ 2,
                                  LC_ALK_F0013 == "3" ~ 3,
                                  LC_ALK_F0013 == "4" ~ 4,
                                  TRUE ~ NA_integer_),
         LC_ALK_F0014 = case_when(LC_ALK_F0014 == "0" ~ 0,
                                  LC_ALK_F0014 == "1" ~ 1,
                                  LC_ALK_F0014 == "2" ~ 2,
                                  LC_ALK_F0014 == "3" ~ 3,
                                  LC_ALK_F0014 == "4" ~ 4,
                                  TRUE ~ NA_integer_),
         LC_ALK_F0015 = case_when(LC_ALK_F0015 == "0" ~ 0,
                                  LC_ALK_F0015 == "1" ~ 1,
                                  LC_ALK_F0015 == "2" ~ 2,
                                  LC_ALK_F0015 == "3" ~ 3,
                                  LC_ALK_F0015 == "4" ~ 4,
                                  TRUE ~ NA_integer_),
         LC_ALK_F0016 = case_when(LC_ALK_F0016 == "0" ~ 0,
                                  LC_ALK_F0016 == "1" ~ 1,
                                  LC_ALK_F0016 == "2" ~ 2,
                                  LC_ALK_F0016 == "3" ~ 3,
                                  LC_ALK_F0016 == "4" ~ 4,
                                  TRUE ~ NA_integer_),
         LC_ALK_F0017 = case_when(LC_ALK_F0017 == "0" ~ 0,
                                  LC_ALK_F0017 == "1" ~ 1,
                                  LC_ALK_F0017 == "2" ~ 2,
                                  LC_ALK_F0017 == "3" ~ 3,
                                  LC_ALK_F0017 == "4" ~ 4,
                                  TRUE ~ NA_integer_),
         LC_ALK_F0018 = case_when(LC_ALK_F0018 == "0" ~ 0,
                                  LC_ALK_F0018 == "1" ~ 1,
                                  LC_ALK_F0018 == "2" ~ 2,
                                  LC_ALK_F0018 == "3" ~ 3,
                                  LC_ALK_F0018 == "4" ~ 4,
                                  TRUE ~ NA_integer_),)
#TODO always check visually if applicable for current sample
alk_df[is.na(alk_df)] <- 0
alk_df <- alk_df %>% mutate(alc_score = rowSums(across(LC_ALK_F0009:LC_ALK_F0018)))

LC_df <- LC_df %>% mutate(alc_score = alk_df$alc_score)

ggplot(data = LC_df) + geom_freqpoly(aes(x = alc_score))
```

#### blood
```{r blood}
blood_df <- LC_df %>% select(SIC, contains("GRBB"), contains("IL6"), contains("CRPHS"))

LC_df <- LC_df %>% mutate(il6_blood_score = IL6_S_NUM_VALUE,
                          crp_blood_score = CRPHS_S_NUM_VALUE,
                          #il_crp_blood_proc_score = il6_blood_score/crp_blood_score,
                          basophile_blood_score = GRBB_E_BAP_E_NUM_VALUE,
                          eosinophile_blood_score = GRBB_E_EOP_E_NUM_VALUE,
                          erythrocytes_blood_score = GRBB_E_RBC_E_NUM_VALUE,
                          haematokrit_blood_score = GRBB_E_HCT_E_NUM_VALUE,
                          haemoglobin_blood_score = GRBB_E_HGBK_E_NUM_VALUE,
                          haemoglobin_si_blood_score = GRBB_E_HGB_E_NUM_VALUE,
                          leukocytes_blood_score = GRBB_E_WBC_E_NUM_VALUE,
                          lymphocytes_blood_score = GRBB_E_LYP_E_NUM_VALUE,
                          mch_blood_score = GRBB_E_MCHK_E_NUM_VALUE,
                          mchc_blood_score = GRBB_E_MCHCK_E_NUM_VALUE,
                          erythrocyte_volumne_blood_score = GRBB_E_MCV_E_NUM_VALUE,
                          thrombocye_volume_blood_score = GRBB_E_MPV_E_NUM_VALUE,
                          monocytes_blood_score = GRBB_E_MOP_E_NUM_VALUE,
                          neutrophiles_blood_score = GRBB_E_NEP_E_NUM_VALUE,
                          retikulocytes_blood_score = GRBB_E_RETI_E_NUM_VALUE,
                          thrombocytes_blood_score = GRBB_E_PLT_E_NUM_VALUE) #%>%
  #mutate(neutro_lympho_blood_proc_score = neutrophiles_blood_score/lymphocytes_blood_score)

#test_score <- blood_df %>% select(contains(score))                          

# look out for cut off vals in data
for (colname in (colnames(blood_df %>% select(contains("FLAG"))))){
  
  print(colname)
  print(sum(blood_df[[colname]] != 1, na.rm = TRUE))
} 

blood_scores <- colnames(LC_df %>% select(contains("score")))


for(blood in blood_scores){
  plot = ggplot(data=LC_df) + geom_freqpoly(aes_string(x=blood))
  print(plot)
}

# next, impute il6 since distr. cut off! (! not enough data points..)

# library(lnormimp)
# 
# test_df <- LC_df %>% na.omit()
# data_imputed <- lnormimp(
#   test_df$il6_blood_score,
#   censn = c(97, 7),
#   cutoff = 3.5
# )

# lets have il6 categorically encoded
LC_df <- LC_df %>% mutate(il6_blood_score = case_when(
  il6_blood_score <= 3.5 ~ 0,
  il6_blood_score >3.5 ~ 1,
  .default = il6_blood_score
))
 
```
#### Others
```{r others}
LC_df <- LC_df %>% mutate(sex_score = as.factor(SEX), 
                          age_score = LC_STATUS_AGE)
```

#### Self Reported Symptoms
```{r}
# starting with 1/0 self-reported symptoms
symptom_scores <- colnames(LC_df) %>% grep(pattern = "Cov4", value = TRUE)

modify_names <- function(name) {
  paste0(name, "_symptom")
}

# rename all columns using the modify_names function
LC_df <- LC_df %>% rename_with(modify_names, all_of(symptom_scores)) %>% mutate(across(contains("symptom"), factor))

```

#### PHQ
```{r phq}

# phq maybe also good for rating of our symptoms
# phq_df <- LC_df %>% select(SIC, contains("PHQ")) 
# 
# phq_score <- phq_df %>% 
#   select(LC_PHQ_F0010:LC_PHQ_F0024) %>%
#   mutate(phq_score = rowSums(across(where(is.numeric)), na.rm = TRUE))
# 
# LC_df <- LC_df %>% mutate(phq_score = phq_score$phq_score)
# 
# ggplot(data = LC_df) + geom_freqpoly(aes(phq_score))

phq_vars <- colnames(LC_df %>% select(contains("PHQ")) %>% 
  select(LC_PHQ_F0010:LC_PHQ_F0038))
  


view(LC_df[phq_vars])

# LC_df <- LC_df %>%
#   mutate(stomach_ache_phq_symptom = factor(LC_PHQ_F0010, exclude = NA),
#          back_pain_phq_symptom = factor(LC_PHQ_F0011, exclude = NA),
#          joint_pain_phq_symptom = factor(LC_PHQ_F0012, exclude = NA),
#          headache_phq_symptom = factor(LC_PHQ_F0013, exclude = NA),
#          breast_pain_phq_symptom = factor(LC_PHQ_F0015, exclude = NA),
#          dizziness_phq_symptom = factor(LC_PHQ_F0016, exclude = NA),
#          fainting_phq_symptom = factor(LC_PHQ_F0017, exclude =  NA),
#          heart_phq_symptoms = factor(LC_PHQ_F0018, exclude = NA),
#          dyspnea_phq_symptoms = factor(LC_PHQ_F0019, exclude = NA),
#          intercourse_phq_symptoms = factor(LC_PHQ_F0020, exclude = NA),
#          diarrhea_phq_symptoms = factor(LC_PHQ_F0021, exclude = NA),
#          digestion_phq_symptoms = factor(LC_PHQ_F0022, exclude = NA),
#          menstruation_phq_symptoms = factor(LC_PHQ_F0025, exclude = NA),
#          sleep_phq_symptoms = factor(LC_PHQ_F0024, exclude = NA),
#          tiredness_phq_symptoms = factor(LC_PHQ_F0023, exclude = NA))

LC_df <- LC_df %>%
  mutate(stomach_ache_phq_symptom = LC_PHQ_F0010, 
         back_pain_phq_symptom = LC_PHQ_F0011, 
         joint_pain_phq_symptom = LC_PHQ_F0012, 
         headache_phq_symptom = LC_PHQ_F0013, 
         breast_pain_phq_symptom = LC_PHQ_F0015, 
         dizziness_phq_symptom = LC_PHQ_F0016,
         fainting_phq_symptom = LC_PHQ_F0017, 
         heart_phq_symptom = LC_PHQ_F0018, 
         dyspnea_phq_symptom = LC_PHQ_F0019,
         intercourse_phq_symptom = LC_PHQ_F0020, 
         diarrhea_phq_symptom = LC_PHQ_F0021, 
         digestion_phq_symptom = LC_PHQ_F0022, 
         menstruation_phq_symptom = LC_PHQ_F0025, 
         sleep_phq_symptom = LC_PHQ_F0024, 
         tiredness_phq_symptom = LC_PHQ_F0023)


phq_variables <- LC_df %>% select(contains("phq_symptom")) %>% colnames(.)
LC_df <- LC_df %>% 
  mutate(across(contains("phq_symptom"), 
                ~ case_when(. == 2 ~ 1, 
                            TRUE ~ .)))

LC_df <- LC_df %>% mutate(across(all_of(phq_variables),
                        as.factor))
LC_df <- LC_df %>% mutate(headache_phq_symptom = case_when(
  LC_PHQ_F0014 == 0 ~ factor(0),
  .default = headache_phq_symptom))

#view(LC_df %>% select(headache_phq_symptom, LC_PHQ_F0013, LC_PHQ_F0014))

```

#### RehabNeQ
```{r}
#view(LC_df %>% select(contains("REHABNEQ")))
path <- "/data/p_02571/lifedata/data/PV0712_T01440_NODUP.xlsx"

reha_df <- read_xlsx(path)
LC_df <- merge(LC_df, reha_df, by = "SIC", all.x = TRUE)

#LC_df <- LC_df %>% mutate(prolonged_symptoms = reha_df$LC_REHABNEQ_F0055)

```

```{r}
#TODO decide how to define the control group - rehab + cov infection;  severity/symptom load - or both?

tibble(prolonged_symptoms = LC_df$LC_REHABNEQ_F0055.x,
       n_sf = LC_df$`LC_#symptoms`, cov_pos = LC_df$Cov_pos,
       duration = LC_df$LC_STATUS_DURATION, ) %>% view()

cut(LC_df$age_score, 
                   breaks=c(-Inf, 28, 38, 48, 58, 68, 78, Inf))
LC_df

test <- read.table("/data/pt_02571/Data/preprocessed/fixel_analysis/PV712_ids_dates", sep = ",", header = TRUE)
test <- merge(LC_df, as_tibble(test), by = "LI_Nr")

tibble(prolonged_symptoms = test$LC_REHABNEQ_F0055.x,
       symptoms = test$`LC_#symptoms`, cov_pos = test$Cov_pos,
       duration = test$LC_STATUS_DURATION, date = test$Exp_Date.y, sex = LC_df$sex_score, age = test$age_score, LI_Nr = test$LI_Nr) %>% 
  mutate(skyra = case_when(date > "2022-12-05" ~ 1,                                                                                                                    .default = 0))  %>%
  mutate(symptoms = as.character(symptoms)) %>% mutate(symptoms = as.numeric(symptoms))  %>%
  filter(sex == "male", skyra == 1,  40 <= age & age <= 50) %>%
           view()


select_df <- tibble(prolonged_symptoms = test$LC_REHABNEQ_F0055.x,
       symptoms = test$`LC_#symptoms`, cov_pos = test$Cov_pos,
       duration = test$LC_STATUS_DURATION, date = test$Exp_Date.y, sex = LC_df$sex_score, age = test$age_score, LI_Nr = test$LI_Nr) %>% 
  mutate(skyra = case_when(date > "2022-12-05" ~ 1,                                                                                                                    .default = 0))  %>%
  mutate(symptoms = as.character(symptoms)) %>% mutate(symptoms = as.numeric(symptoms))   


merge(LC_df %>% filter(LI_Nr %in% FOD_template) %>% select(LI_Nr, contains("phq_symptom")), fod_df, by = "LI_Nr") %>% view() #%>% filter(if_any(contains("phq"), ~ . > 1)) %>% view()

#view(fod_df %>% filter(LI_Nr %in% c("LI08862673")))
# didn't find LI08862673 in slicedir output, changed male, skyra, 52 y LC (many symptoms) to LI08856271
bin_1 <- c("LI08796757", "LI08775630", "LI08778811", "LI08795817", "LI00393030", "LI03338639", "LI08827635", "LI08905071")
 bin_2 <- c("LI02568858","LI08777570", "LI0884397X", "LI00984279", "LI08841617", "LI04122258", "LI08791878", "LI00244270")
 bin_3 <- c("LI00351778", "LI02044730", "LI00234157", "LI08856271", "LI0266387X", "LI08070875", "LI01530530", "LI08898936")


#view(fod_df %>% filter(LI_Nr %in% c("LI01872258")))
# LI01872258 had no good mask, f, 63, skyra == 0, no symptoms not prolonged; changed to LI03232919
bin_4 <- c("LI04105215", "LI08872518", "LI03232919", "LI03304557", "LI03678936", "LI08825575", "LI08928512")
 FOD_template <- c(bin_1, bin_2, bin_3, bin_4)
 select_df <- tibble(prolonged_symptoms = test$LC_REHABNEQ_F0055.x,
       symptoms = test$`LC_#symptoms`, cov_pos = test$Cov_pos,
       duration = test$LC_STATUS_DURATION, date = test$Exp_Date.y, sex = LC_df$sex_score, age = test$age_score, LI_Nr = test$LI_Nr) %>% 
  mutate(skyra = case_when(date > "2022-12-05" ~ 1,                                                                                                                    .default = 0))  %>%
  mutate(symptoms = as.character(symptoms)) %>% mutate(symptoms = as.numeric(symptoms)) 
 
fod_df <- select_df %>%
  filter((LI_Nr %in% FOD_template)) 


# watch out for med anam
LC_df %>% filter(LI_Nr %in% FOD_template) %>% select(contains("MEDIZANAM"), contains("KARDANAM")) %>% select(contains("F0165"), contains("F0168"), contains("F0060"), 
               contains("F0012"), contains("F0171"), contains("F0174"),
               contains("F0178")) %>% view()
#os < 10 --> dysfunction
#ITK snap

test_wm <- sprintf("/data/pt_02571/Data/preprocessed/nipype/diffusion/%s/response_wm.txt", FOD_template)
test_gm <- sprintf("/data/pt_02571/Data/preprocessed/nipype/diffusion/%s/response_gm.txt", FOD_template)
test_csf <- sprintf("/data/pt_02571/Data/preprocessed/nipype/diffusion/%s/response_csf.txt", FOD_template)
write(paste(my_vector, collapse = " "), file = "/data/pt_02571/Data/preprocessed/fixel-analysis/my_file.txt")

verio <- select_df %>% filter((skyra == 0), !(LI_Nr %in% c("LI08862673"))) %>% 
  select(LI_Nr) %>% pull

skyra <- select_df %>% filter((skyra == 1), !(LI_Nr %in% c("LI08862673"))) %>% 
  select(LI_Nr) %>% pull

  
test_paths_verio_csf <- sprintf("/data/pt_02571/Data/preprocessed/nipype/diffusion/%s/response_csf.txt",  verio)
test_paths_skyra_csf <- sprintf("/data/pt_02571/Data/preprocessed/nipype/diffusion/%s/response_csf.txt",  
                                     skyra)
write(paste(test_paths_verio_csf, collapse = " "), file = "/data/pt_02571/Data/preprocessed/fixel_analysis/avg_csf_verio.txt")
write(paste(test_paths_skyra_csf, collapse = " "), file = "/data/pt_02571/Data/preprocessed/fixel_analysis/avg_csf_skyra.txt")


test_paths_verio_gm <- sprintf("/data/pt_02571/Data/preprocessed/nipype/diffusion/%s/response_gm.txt",
                               verio)
test_paths_skyra_gm <- sprintf("/data/pt_02571/Data/preprocessed/nipype/diffusion/%s/response_gm.txt", 
                                    skyra)
write(paste(test_paths_verio_gm, collapse = " "), file = "/data/pt_02571/Data/preprocessed/fixel_analysis/avg_gm_verio.txt")
write(paste(test_paths_skyra_gm, collapse = " "), file = "/data/pt_02571/Data/preprocessed/fixel_analysis/avg_gm_skyra.txt")



test_paths_verio_wm <- sprintf("/data/pt_02571/Data/preprocessed/nipype/diffusion/%s/response_wm.txt",
                               verio)
test_paths_skyra_wm <- sprintf("/data/pt_02571/Data/preprocessed/nipype/diffusion/%s/response_wm.txt", 
                             skyra)
write(paste(test_paths_verio_wm, collapse = " "), file = "/data/pt_02571/Data/preprocessed/fixel_analysis/avg_wm_verio.txt")

write(paste(test_paths_skyra_wm, collapse = " "), file = "/data/pt_02571/Data/preprocessed/fixel_analysis/avg_wm_skyra.txt")

# scanner_type <- c("verio", "skyra")
# response_function <- c("gm", "wm", "csf")
# 
# for(st in scanner_type){
#   for(rf in responste_function){
#     
#   }
# }
```

```{r dhollander}
subjects <- select_df %>% filter(!(LI_Nr %in% c("LI08862673"))) %>% 
  select(LI_Nr) %>% pull
cmd <- sprintf("dwi2response dhollander /data/pt_02571/Data/preprocessed/nipype/diffusion/%s/eddy_corrected_unbiased.mif /data/pt_02571/Data/preprocessed/nipype/diffusion/%s/response_wm.txt /data/pt_02571/Data/preprocessed/nipype/diffusion/%s/response_gm.txt /data/pt_02571/Data/preprocessed/nipype/diffusion/%s/response_csf.txt -force", subjects, subjects, subjects, subjects)
slurm_dir <- file.path("/data/pt_02571/Data/preprocessed", "sbatch", "diffusion")
if(!dir.exists(slurm_dir)){dir.create(slurm_dir, recursive = TRUE)}
fn_sh <-  file.path(slurm_dir, sprintf("%s.sh", "dhollander_mrtrix3T"))
mem_req <- 5000
tim_req <- "0-05:00"
con <- file(fn_sh)

open(con, "w")
          # writeLines(c(sprintf("#!/bin/bash\n#"),
          #              sprintf("#SBATCH -n 4"),
          #              sprintf("#SBATCH -N 1"),
          #              sprintf("#SBATCH --mem=%d", mem_req),
          #              sprintf("#SBATCH --time=%s", tim_req),
          #              sprintf("#SBATCH --job-name %s_ss3t", type),
          #              sprintf("#SBATCH --mail-type=begin"),
          #              sprintf("#SBATCH --mail-type=end"),
          #              sprintf("#SBATCH --mail-type=fail"),
          #              sprintf("#SBATCH --mail-user=%s@cbs.mpg.de", system("echo $USER", intern = TRUE)),
          # sprintf("#SBATCH -o %s/%s_ss3t.out",
          #         slurm_dir, type),
          # sprintf("#SBATCH -e %s/%s_33t.err\n",
          #         slurm_dir, type)
          # ), con)

          # write the film_gls command to the sbatch file
          writeLines(cmd, con, sep = "\n\n")

          # close connection and make sbatch file executable
          close(con)
```


```{r fixel analyses}
# make loop:
scanner <- c("skyra", "verio")
path <- "/data/pt_02571/Data/preprocessed/nipype/diffusion"
fixel_folder <- "/data/pt_02571/Data/preprocessed/fixel_analysis"

fod_df <- fod_df %>% mutate(skyra = case_when(
  skyra == 1 ~ "skyra",
  skyra == 0 ~ "verio"
))

for(type in scanner){
  if(type == "verio") subjects <- verio else subjects <- skyra
  
  
  cmd <- sprintf("ss3t_csd_beta1 %s/%s/eddy_corrected_unbiased_upsampled.mif %s/%s_group_average_response_wm.txt %s/%s/wmfod.mif %s/%s_group_average_response_gm.txt %s/%s/gm.mif  %s/%s_group_average_response_csf.txt %s/%s/csf.mif -mask %s/%s/eddy_dwi_mask_upsampled.mif -force", 
                 path, subjects, fixel_folder, type, path, subjects, fixel_folder,
                 type, path, subjects, fixel_folder, type, path, subjects, path, subjects)
  #system(cmd)
  #write set up part of sbatch file
  slurm_dir <- file.path("/data/pt_02571/Data/preprocessed", "sbatch", "diffusion")
  if(!dir.exists(slurm_dir)){dir.create(slurm_dir, recursive = TRUE)}
  fn_sh <-  file.path(slurm_dir, sprintf("fod_%s_ss3t.sh", type))
  mem_req <- 5000
  tim_req <- "0-05:00"
  con <- file(fn_sh)
  open(con, "w")
          # writeLines(c(sprintf("#!/bin/bash\n#"),
          #              sprintf("#SBATCH -n 4"),
          #              sprintf("#SBATCH -N 1"),
          #              sprintf("#SBATCH --mem=%d", mem_req),
          #              sprintf("#SBATCH --time=%s", tim_req),
          #              sprintf("#SBATCH --job-name %s_ss3t", type),
          #              sprintf("#SBATCH --mail-type=begin"),
          #              sprintf("#SBATCH --mail-type=end"),
          #              sprintf("#SBATCH --mail-type=fail"),
          #              sprintf("#SBATCH --mail-user=%s@cbs.mpg.de", system("echo $USER", intern = TRUE)),
          # sprintf("#SBATCH -o %s/%s_ss3t.out",
          #         slurm_dir, type),
          # sprintf("#SBATCH -e %s/%s_33t.err\n",
          #         slurm_dir, type)
          # ), con)

          # write the film_gls command to the sbatch file
          writeLines(cmd, con, sep = "\n\n")

          # close connection and make sbatch file executable
          close(con)
          #system(sprintf("chmod +x %s",fn_sh))

          # submit to slurm
         # system(sprintf("sbatch %s",fn_sh))
}



#TODO 
# prep for mtnormalize
subjects <- select_df %>%select(LI_Nr) %>% pull() %>% unique
subjects <- select_df %>% filter(!(LI_Nr %in% c("LI08862673"))) %>% 
  select(LI_Nr) %>% pull
subjects <- "LI00234157"
path <- "/data/pt_02571/Data/preprocessed/nipype/diffusion"
slurm_dir <- file.path("/data/pt_02571/Data/preprocessed", "sbatch", "diffusion")
cmd <- sprintf("fslmaths %s/%s/eddy_dwi_mask_upsampled.nii.gz -ero -bin %s/%s/eroded_mask_upsampled.nii.gz", path, subjects, path, subjects)

slurm_dir <- file.path("/data/pt_02571/Data/preprocessed", "sbatch", "diffusion")
if(!dir.exists(slurm_dir)){dir.create(slurm_dir, recursive = TRUE)}
fn_sh <-  file.path(slurm_dir, sprintf("%s_ero_LI00234157.sh", "masks"))
mem_req <- 5000
tim_req <- "0-05:00"
con <- file(fn_sh)
open(con, "w")

# write the film_gls command to the sbatch file
writeLines(cmd, con, sep = "\n\n")

# close connection and make sbatch file executable
close(con)



#subjects <- select_df %>%select(LI_Nr) %>% pull() %>% unique
path <- "/data/pt_02571/Data/preprocessed/nipype/diffusion"
slurm_dir <- file.path("/data/pt_02571/Data/preprocessed", "sbatch", "diffusion")
cmd <- sprintf("fslmaths %s/%s/eroded_mask_upsampled.nii.gz -ero -bin %s/%s/2nd_eroded_mask_upsampled.nii.gz", path, subjects, path, subjects)

slurm_dir <- file.path("/data/pt_02571/Data/preprocessed", "sbatch", "diffusion")
if(!dir.exists(slurm_dir)){dir.create(slurm_dir, recursive = TRUE)}
fn_sh <-  file.path(slurm_dir, sprintf("%s_2nd_ero_LI00234157.sh", "masks"))
mem_req <- 5000
tim_req <- "0-05:00"
con <- file(fn_sh)
open(con, "w")

# write the film_gls command to the sbatch file
writeLines(cmd, con, sep = "\n\n")

# close connection and make sbatch file executable
close(con)

#LI08862673
fn_sh <-  file.path(slurm_dir, sprintf("%s_2nd_ero.sh", "masks"))

con <- file(fn_sh)
open(con, "w")

# write the film_gls command to the sbatch file
writeLines(cmd, con, sep = "\n\n")

# close connection and make sbatch file executable
close(con)

```


mtnormalize
```{r}
subjects <- select_df %>% filter(!(LI_Nr %in% c("LI08862673"))) %>% 
  select(LI_Nr) %>% pull
#LI08862673 has no mask

norm_subjects <- c()
no_mask <- c()
for(subject in subjects){
  eddy_file <- sprintf("/data/pt_02571/Data/preprocessed/nipype/diffusion/%s/eddy_corrected_unbiased_upsampled.nii.gz", subject)
  mask_file <- sprintf("/data/pt_02571/Data/preprocessed/nipype/diffusion/%s/2nd_eroded_mask_upsampled.nii.gz", subject)
  if(!(file.exists(eddy_file) & file.exists(mask_file))){
    print("no file")
    no_mask <- c(no_mask, subject)
  }
  else{norm_subjects <- c(norm_subjects, subject)}
  
}


path <- "/data/pt_02571/Data/preprocessed/nipype/diffusion"
slurm_dir <- file.path("/data/pt_02571/Data/preprocessed", "sbatch", "diffusion")
cmd <- sprintf("mtnormalise %s/%s/wmfod.mif %s/%s/wmfod_norm.mif %s/%s/gm.mif %s/%s/gm_norm.mif %s/%s/csf.mif %s/%s/csf_norm.mif -mask %s/%s/2nd_eroded_mask_upsampled.mif", path, norm_subjects, path, norm_subjects, path, norm_subjects, path, norm_subjects, path, norm_subjects, path, norm_subjects, path, norm_subjects)

slurm_dir <- file.path("/data/pt_02571/Data/preprocessed", "sbatch", "diffusion")
if(!dir.exists(slurm_dir)){dir.create(slurm_dir, recursive = TRUE)}
fn_sh <-  file.path(slurm_dir, sprintf("2nd_ero_mtnormalise.sh"))
mem_req <- 500000
tim_req <- "1-10:00"
con <- file(fn_sh)
open(con, "w")

# write the film_gls command to the sbatch file
writeLines(cmd, con, sep = "\n\n")

# close connection and make sbatch file executable
close(con)

cmd <- sprintf("mrconvert /data/pt_02571/Data/preprocessed/nipype/diffusion/%s/2nd_eroded_mask_upsampled.nii.gz /data/pt_02571/Data/preprocessed/nipype/diffusion/%s/2nd_eroded_mask_upsampled.mif -force", norm_subjects, norm_subjects)
fn_sh <- file.path(slurm_dir, sprintf("2nd_ero_convert.sh"))
con <- file(fn_sh)
open(con, "w")

# write the film_gls command to the sbatch file
writeLines(cmd, con, sep = "\n\n")

# close connection and make sbatch file executable
close(con)





```
FOD template
```{r}
fod_subjects <- fod_df %>% select(LI_Nr) %>% pull() %>% unique()
template_dir <- file.path("/data/pt_02571/Data/preprocessed/template")
cmd <- sprintf("ln -sr %s/%s/wmfod_norm.mif %s/fod_input/%s_PRE.mif", path, fod_subjects, template_dir, fod_subjects)
fn_sh <- file.path(slurm_dir, sprintf("symbolic_link_fod.sh"))
con <- file(fn_sh)
open(con, "w")

# write the film_gls command to the sbatch file
writeLines(cmd, con, sep = "\n\n")

# close connection and make sbatch file executable
close(con)


cmd <- sprintf("ln -sr %s/%s/2nd_eroded_mask_upsampled.mif %s/mask_input/%s_PRE.mif", path, fod_subjects, template_dir, fod_subjects)
fn_sh <- file.path(slurm_dir, sprintf("symbolic_link_masks.sh"))
con <- file(fn_sh)
open(con, "w")

# write the film_gls command to the sbatch file
writeLines(cmd, con, sep = "\n\n")

# close connection and make sbatch file executable
close(con)

```

do command, then:
```{r}

cmd <- "population_template /data/pt_02571/Data/preprocessed/template/fod_input -mask_dir /data/pt_02571/Data/preprocessed/template/mask_input /data/pt_02571/Data/preprocessed/template/wmfod_template.mif -voxel_size 1.25"
mem_req <- 500000
tim_req <- "1-10:00"
fn_sh <- file.path(slurm_dir, "fod_template.sh")
con <- file(fn_sh)
open(con, "w")
writeLines(c(sprintf("#!/bin/bash\n#"),
                    sprintf("#SBATCH -n 4"),
                    sprintf("#SBATCH -N 1"),
                    sprintf("#SBATCH --mem=%d", mem_req),
                    sprintf("#SBATCH --time=%s", tim_req),
                    sprintf("#SBATCH --job-name fod_temp"),
                    sprintf("#SBATCH --mail-type=begin"),
                    sprintf("#SBATCH --mail-type=end"),
                    sprintf("#SBATCH --mail-type=fail"),
                    sprintf("#SBATCH --mail-user=%s@cbs.mpg.de", system("echo $USER", intern = TRUE)),
                    sprintf("#SBATCH -o %s/fod_temp.out", 
                             slurm_dir),
                    sprintf("#SBATCH -e %s/fod_temp.err\n", 
                             slurm_dir)
                     ), con)
        
        # write the film_gls command to the sbatch file 
        writeLines(cmd, con, sep = "\n\n")
        
        # close connection and make sbatch file executable
        close(con)
        system(sprintf("chmod +x %s",fn_sh))
        
        # submit to slurm
        system(sprintf("sbatch %s",fn_sh))

```

registration to template
```{r}
path <- "/data/pt_02571/Data/preprocessed/nipype/diffusion"
slurm_dir <- file.path("/data/pt_02571/Data/preprocessed", "sbatch", "diffusion")
subjects <- select_df %>% filter(!(LI_Nr %in% c("LI08862673"))) %>% 
  select(LI_Nr) %>% pull
cmd <- sprintf("mrregister %s/%s/wmfod_norm.mif -mask1 %s/%s/eddy_dwi_mask_upsampled.mif /data/pt_02571/Data/preprocessed/template/wmfod_template.mif -nl_warp %s/%s/subject2template_warp.mif %s/%s/template2subject_warp.mif", path, subjects, path, subjects, path, subjects, path, subjects)
fn_sh <- file.path(slurm_dir, sprintf("mrregister.sh"))
con <- file(fn_sh)
open(con, "w")

# write the film_gls command to the sbatch file
writeLines(cmd, con, sep = "\n\n")

# close connection and make sbatch file executable
close(con)



path <- "/data/pt_02571/Data/preprocessed/nipype/diffusion"
slurm_dir <- file.path("/data/pt_02571/Data/preprocessed", "sbatch", "diffusion")
cmd <- sprintf("mtnormalise %s/%s/wmfod.mif %s/%s/wmfod_norm.mif %s/%s/gm.mif %s/%s/gm_norm.mif %s/%s/csf.mif %s/%s/csf_norm.mif -mask %s/%s/2nd_eroded_mask_upsampled.mif", path, norm_subjects, path, norm_subjects, path, norm_subjects, path, norm_subjects, path, norm_subjects, path, norm_subjects, path, norm_subjects)
```

mask intersection
```{r}
path <- "/data/pt_02571/Data/preprocessed/nipype/diffusion"
slurm_dir <- file.path("/data/pt_02571/Data/preprocessed", "sbatch", "diffusion")
subjects <- select_df %>% filter(!(LI_Nr %in% c("LI08862673"))) %>% 
  select(LI_Nr) %>% pull
cmd <- sprintf("mrtransform %s/%s/eddy_dwi_mask_upsampled.mif -warp %s/%s/subject2template_warp.mif -interp nearest -datatype bit %s/%s/dwi_mask_in_template_space.mif", path, subjects, path, subjects, path, subjects)
fn_sh <- file.path(slurm_dir, sprintf("11_a_mask_to_template.sh"))
con <- file(fn_sh)
open(con, "w")

# write the film_gls command to the sbatch file
writeLines(cmd, con, sep = "\n\n")

# close connection and make sbatch file executable
close(con)


path <- "/data/pt_02571/Data/preprocessed/nipype/diffusion"
slurm_dir <- file.path("/data/pt_02571/Data/preprocessed", "sbatch", "diffusion")
subjects <- select_df %>% filter(!(LI_Nr %in% c("LI08862673"))) %>% 
  select(LI_Nr) %>% pull
masks <- paste(sprintf("%s/%s/dwi_mask_in_template_space.mif", path, subjects), collapse = " ")
cmd <- sprintf("mrmath %s min /data/pt_02571/Data/preprocessed/template/template_mask.mif -datatype bit",masks)
fn_sh <- file.path(slurm_dir, sprintf("11_b_mask_intersection.sh"))
con <- file(fn_sh)
open(con, "w")

# write the film_gls command to the sbatch file
writeLines(cmd, con, sep = "\n\n")

# close connection and make sbatch file executable
close(con)
#########################
# mask without some IDs #
#########################

no_signal <- c("LI01213470","LI08846738","LI08921295", "LI08896792", "LI08892876", "LI08891199", "LI08888219", "LI08852996", "LI08842654", "LI08840881", "LI08827635", "LI08823394", "LI08822236", "LI08778811", "LI08775630", "LI04105215", "LI02568858", "LI02050539","LI00573018", "LI0266387X", "LI03304557", "LI01530530", "LI00995633", "LI00393030", "LI00351778", "LI00303375", "LI08892876", "LI08905071", "LI08916691", "LI08921295")
path <- "/data/pt_02571/Data/preprocessed/nipype/diffusion"
slurm_dir <- file.path("/data/pt_02571/Data/preprocessed", "sbatch", "diffusion")
subjects <- select_df %>% filter(!(LI_Nr %in% c("LI08862673"))) %>% filter(!(LI_Nr %in% bad_mask)) %>% 
  select(LI_Nr) %>% pull
masks <- paste(sprintf("%s/%s/dwi_mask_in_template_space.mif", path, subjects), collapse = " ")
cmd <- sprintf("mrmath %s min /data/pt_02571/Data/preprocessed/template/bulb_template_mask.mif -datatype bit -force",masks)
fn_sh <- file.path(slurm_dir, sprintf("11_c_bulb_mask_intersection.sh"))
con <- file(fn_sh)
open(con, "w")

# write the film_gls command to the sbatch file
writeLines(cmd, con, sep = "\n\n")

# close connection and make sbatch file executable
close(con)

no_bulb <- c("LI08783234","LI08800170","LI08822236","LI0880405X", "LI0893465X", "LI00984279", "LI01530530", "LI01872258", "LI03338639", "LI04270793", "LI04411853", "LI08773557", "LI08795817", "LI08796951", "LI08821273", "LI08821732", "LI08822212", "LI08823394", "LI08827635", "LI08835457", "LI08837517", "LI08845497", "LI08921295", "LI01530530", "LI01654655", "LI03338639", "LI08773557","LI08795817", "LI08822974", "LI08823394", "LI08827635", "LI08835457", "LI08837517", "LI08916691", "LI08921295")
#no_bulb <- c("LI08783234","LI08800170","LI08822236")

bad_mask <- c(no_signal, no_bulb) %>% unique

c("LI00234157", "LI01654655", "LI03750879", "LI04105215", "")
```

optimized brain mask
```{r}
cmd <- sprintf("mrconvert /data/pt_02571/Data/preprocessed/nipype/diffusion/%s/eddy_corrected_unbiased_upsampled.mif /data/pt_02571/Data/preprocessed/nipype/diffusion/%s/eddy_corrected_unbiased_upsampled.nii.gz -force \n\nmrconvert /data/pt_02571/Data/preprocessed/nipype/diffusion/%s/eddy_dwi_mask_upsampled.mif /data/pt_02571/Data/preprocessed/nipype/diffusion/%s/eddy_dwi_mask_upsampled.nii.gz -force", bad_mask, bad_mask, bad_mask, bad_mask)

#cmd <- sprintf("mrconvert /data/pt_02571/Data/preprocessed/nipype/diffusion/%s/eddy_dwi_mask_upsampled.mif /data/pt_02571/Data/preprocessed/nipype/diffusion/%s/eddy_dwi_mask_upsampled.nii.gz -force", bad_mask, bad_mask)

fn_sh <- file.path(slurm_dir, sprintf("11_z_bad_mask.sh"))
con <- file(fn_sh)
open(con, "w")

# write the film_gls command to the sbatch file
writeLines(cmd, con, sep = "\n\n")

# close connection and make sbatch file executable
close(con)

# new brain mask
#mrconvert /data/pt_02571/Data/preprocessed/nipype/diffusion/%s/eddy_corrected_unbiased_upsampled.nii.gz /data/pt_02571/Data/preprocessed/nipype/diffusion/%s/eddy_corrected_unbiased_upsampled.nii -force \n\n
cmd <- sprintf("bet2 /data/pt_02571/Data/preprocessed/nipype/diffusion/%s/eddy_corrected_unbiased_upsampled.nii.gz /data/pt_02571/Data/preprocessed/nipype/diffusion/%s/bet2_upsampled.nii.gz -m -f 0.3\n\nmrconvert /data/pt_02571/Data/preprocessed/nipype/diffusion/%s/bet2_upsampled_mask.nii.gz /data/pt_02571/Data/preprocessed/nipype/diffusion/%s/bet2_upsampled_mask.mif -force",bad_mask, 
    bad_mask,bad_mask,bad_mask)
fn_sh <- file.path(slurm_dir, sprintf("11_z_bet_mask.sh"))
con <- file(fn_sh)
open(con, "w")

# write the film_gls command to the sbatch file
writeLines(cmd, con, sep = "\n\n")

# close connection and make sbatch file executable
close(con)


```

Do the following command: fod2fixel -mask ../template/template_mask.mif -fmls_peak_value 0.06 ../template/wmfod_template.mif ../template/fixel_mask
Then: FOD segmentation without reorientation
```{r}
subjects <- select_df %>% filter(!(LI_Nr %in% c("LI08862673"))) %>% 
  select(LI_Nr) %>% pull
root_dir <- "/data/pt_02571/Data/preprocessed"
sub_dir <- file.path(root_dir, "nipype", "diffusion") 
slurm_dir <- file.path(root_dir, "sbatch", "diffusion")
template_dir <- file.path(root_dir, "template")

cmd <- sprintf("mrtransform %s/%s/wmfod_norm.mif -warp %s/%s/subject2template_warp.mif -reorient_fod no %s/%s/fod_in_template_space_NOT_REORIENTED.mif -force",sub_dir,  subjects,
    sub_dir,subjects,sub_dir, subjects)
fn_sh <- file.path(slurm_dir, sprintf("13_fod_not_reorient.sh"))
con <- file(fn_sh)
open(con, "w")

# write the film_gls command to the sbatch file
writeLines(cmd, con, sep = "\n\n")

# close connection and make sbatch file executable
close(con)


cmd <- sprintf("fod2fixel -mask %s/template_mask.mif %s/%s/fod_in_template_space_NOT_REORIENTED.mif %s/%s/fixel_in_template_space_NOT_REORIENTED -afd fd.mif -force",template_dir, 
    sub_dir,subjects,sub_dir, subjects)
fn_sh <- file.path(slurm_dir, sprintf("14_FOD_FD.sh"))
con <- file(fn_sh)
open(con, "w")

# write the film_gls command to the sbatch file
writeLines(cmd, con, sep = "\n\n")

# close connection and make sbatch file executable
close(con)



cmd <- sprintf("fixelreorient %s/%s/fixel_in_template_space_NOT_REORIENTED %s/%s/subject2template_warp.mif %s/%s/fixel_in_template_space -force", sub_dir, subjects, 
    sub_dir,subjects,sub_dir, subjects)
fn_sh <- file.path(slurm_dir, sprintf("15_FOD_FD_reorient.sh"))
con <- file(fn_sh)
open(con, "w")

# write the film_gls command to the sbatch file
writeLines(cmd, con, sep = "\n\n")

# close connection and make sbatch file executable
close(con)

cmd <- sprintf("fixelcorrespondence %s/%s/fixel_in_template_space/fd.mif %s/fixel_mask %s/fd %s_PRE.mif", sub_dir, subjects, template_dir, template_dir, subjects)
fn_sh <- file.path(slurm_dir, sprintf("16_FOD_fixel_match.sh"))
con <- file(fn_sh)
open(con, "w")

# write the film_gls command to the sbatch file
writeLines(cmd, con, sep = "\n\n")

# close connection and make sbatch file executable
close(con)

cmd <- sprintf("warp2metric %s/%s/subject2template_warp.mif -fc %s/fixel_mask %s/fc %s.mif", sub_dir, subjects, template_dir, template_dir, subjects)
fn_sh <- file.path(slurm_dir, sprintf("17_FC.sh"))
con <- file(fn_sh)
open(con, "w")

# write the film_gls command to the sbatch file
writeLines(cmd, con, sep = "\n\n")

# close connection and make sbatch file executable
close(con)

cmd <- sprintf("mrcalc %s/fc/%s.mif -log %s/log_fc/%s.mif", template_dir, subjects, template_dir, subjects)
fn_sh <- file.path(slurm_dir, sprintf("17_b_log_FC.sh"))
con <- file(fn_sh)
open(con, "w")

# write the film_gls command to the sbatch file
writeLines(cmd, con, sep = "\n\n")

# close connection and make sbatch file executable
close(con)

cmd <- sprintf("mrcalc %s/fd/%s_PRE.mif %s/fc/%s.mif -mult %s/fdc/%s.mif", template_dir, subjects, template_dir, subjects, template_dir, subjects)
fn_sh <- file.path(slurm_dir, sprintf("18_FDC.sh"))
con <- file(fn_sh)
open(con, "w")

# write the film_gls command to the sbatch file
writeLines(cmd, con, sep = "\n\n")

# close connection and make sbatch file executable
close(con)
``` 

##fixel-connectivity

```{r}
cmd <- "fixelconnectivity fixel_mask/ tracks_2_million_sift.tck matrix/"
mem_req <- 100000
tim_req <- "1-20:00"
fn_sh <- file.path(slurm_dir, "20_fixel_connectivity.sh")
con <- file(fn_sh)
open(con, "w")
writeLines(c(sprintf("#!/bin/bash\n#"),
                    sprintf("#SBATCH -n 4"),
                    sprintf("#SBATCH -N 1"),
                    sprintf("#SBATCH --mem=%d", mem_req),
                    sprintf("#SBATCH --time=%s", tim_req),
                    sprintf("#SBATCH --job-name fod_temp"),
                    sprintf("#SBATCH --mail-type=begin"),
                    sprintf("#SBATCH --mail-type=end"),
                    sprintf("#SBATCH --mail-type=fail"),
                    sprintf("#SBATCH --mail-user=%s@cbs.mpg.de", system("echo $USER", intern = TRUE)),
                    sprintf("#SBATCH -o %s/fod_temp.out", 
                             slurm_dir),
                    sprintf("#SBATCH -e %s/fod_temp.err\n", 
                             slurm_dir)
                     ), con)
        
        # write the film_gls command to the sbatch file 
        writeLines(cmd, con, sep = "\n\n")
        
        # close connection and make sbatch file executable
        close(con)
        system(sprintf("chmod +x %s",fn_sh))
        
        # submit to slurm
        system(sprintf("sbatch %s",fn_sh))
```

## QSM
```{r}

qsm_dir <- file.path("/data/pt_02571/Analysis/longcovid/Preprocessing/CBSQSMTOOLS/")
cmd <- sprintf("%s", skyra)
fn_sh <- file.path(qsm_dir, sprintf("skyra_subjects.txt"))
con <- file(fn_sh)
open(con, "w")
writeLines(cmd, con, sep = "\n")
close(con)
```



## Preprocessing Adult Basis


### Load Data
```{r}
file_path <- "/data/p_02571/lifedata/AdultBasis/PV712_Adult Basis/data/PV0712_datajoin.xlsx"
adult_df <- read_xlsx(file_path)

adult_df <- adult_df %>% rename("SIC" = "TEILNEHMER_SIC")
all_features <- join_by("SIC")

# for 45 participants we have assessment from before
all_features_df <- left_join(adult_df, LC_df, all_features)


```

